<script setup lang="ts">
import type { DrosophilaGene } from "~/composables/services/useGeneService";

const props = defineProps<{
  genes: string[];
  sourceMap: Record<string, string[]>;
  selected: string | null;
}>();

const emit = defineEmits<{
  (e: "update:selected", value: string): void;
}>();

const { xlAndUp } = useDisplay();

const flybaseReportsUrl = (gene: string) =>
  `http://flybase.org/reports/${gene}.html`;

const { fetchDrosophilaGenes } = useGeneService();
const drosophilaGenes: Record<string, DrosophilaGene> = {};

const { data } = await useAsyncData(
  `drosophila-genes-${props.genes.join(",")}`,
  () => fetchDrosophilaGenes(props.genes),
);

(data.value || []).forEach((g) => {
  drosophilaGenes[g.id] = g;
});
</script>

<template>
  <v-table density="compact" class="text-body-2 mb-8">
    <thead>
      <tr>
        <th>Gene ID</th>
        <th>Algorithms</th>
        <th>Gene Symbol</th>
        <th>Gene Name</th>
        <th class="text-center">Show GO Terms</th>
      </tr>
    </thead>
    <tbody>
      <tr v-for="gene in genes" :key="gene">
        <td>
          <OutLink :to="flybaseReportsUrl(gene)">
            {{ gene }}
          </OutLink>
        </td>
        <td>{{ (props.sourceMap[gene] || []).join(", ") }}</td>
        <td>{{ (drosophilaGenes[gene] || {}).symbol || "" }}</td>
        <td
          v-safe-html="
            htmlGeneName((drosophilaGenes[gene] || {}).fullname || '')
          "
        ></td>
        <td class="text-center">
          <v-btn
            variant="text"
            density="compact"
            icon
            @click="emit('update:selected', gene)"
          >
            <v-icon v-if="gene === props.selected" color="primary">
              {{
                !xlAndUp
                  ? "mdi-arrow-down-bold-box"
                  : "mdi-arrow-right-bold-box"
              }}
            </v-icon>
            <v-icon v-else>
              {{
                !xlAndUp
                  ? "mdi-arrow-down-bold-box-outline"
                  : "mdi-arrow-right-bold-box-outline"
              }}
            </v-icon>
          </v-btn>
        </td>
      </tr>
    </tbody>
  </v-table>
</template>
